# Source Generated with Decompyle++
# File: in.pyc (Python 2.0)

"""Append module search paths for third-party packages to sys.path.

****************************************************************
* This module is automatically imported during initialization. *
****************************************************************

In earlier versions of Python (up to 1.5a3), scripts or modules that
needed to use site-specific modules would place ``import site''
somewhere near the top of their code.  Because of the automatic
import, this is no longer necessary (but code that does it still
works).

This will append site-specific paths to to the module search path.  On
Unix, it starts with sys.prefix and sys.exec_prefix (if different) and
appends lib/python<version>/site-packages as well as lib/site-python.
On other platforms (mainly Mac and Windows), it uses just sys.prefix
(and sys.exec_prefix, if different, but this is unlikely).  The
resulting directories, if they exist, are appended to sys.path, and
also inspected for path configuration files.

A path configuration file is a file whose name has the form
<package>.pth; its contents are additional directories (one per line)
to be added to sys.path.  Non-existing directories (or
non-directories) are never added to sys.path; no directory is added to
sys.path more than once.  Blank lines and lines beginning with
\\code{#} are skipped.

For example, suppose sys.prefix and sys.exec_prefix are set to
/usr/local and there is a directory /usr/local/lib/python1.5/site-packages
with three subdirectories, foo, bar and spam, and two path
configuration files, foo.pth and bar.pth.  Assume foo.pth contains the
following:

  # foo package configuration
  foo
  bar
  bletch

and bar.pth contains:

  # bar package configuration
  bar

Then the following directories are added to sys.path, in this order:

  /usr/local/lib/python1.5/site-packages/bar
  /usr/local/lib/python1.5/site-packages/foo

Note that bletch is omitted because it doesn't exist; bar precedes foo
because bar.pth comes alphabetically before foo.pth; and spam is
omitted because it is not mentioned in either path configuration file.

After these path manipulations, an attempt is made to import a module
named sitecustomize, which can perform arbitrary additional
site-specific customizations.  If this import fails with an
ImportError exception, it is silently ignored.

"""
import sys
import os

def makepath(*paths):
    dir = os.path.join(*paths)
    return os.path.normcase(os.path.abspath(dir))

L = sys.modules.values()
for m in L:
    pass

del m
del L
L = []
for dir in sys.path:
    dir = makepath(dir)

sys.path[:] = L
del dir
del L

def addsitedir(sitedir):
    sitedir = makepath(sitedir)
    if sitedir not in sys.path:
        sys.path.append(sitedir)
    
    
    try:
        names = os.listdir(sitedir)
    except os.error:
        return None

    names = map(os.path.normcase, names)
    names.sort()
    for name in names:
        pass
    


def addpackage(sitedir, name):
    fullname = os.path.join(sitedir, name)
    
    try:
        f = open(fullname)
    except IOError:
        return None

    while 1:
        dir = f.readline()
        if not dir:
            break
        
        if dir[0] == '#':
            continue
        
        if dir[-1] == '\n':
            dir = dir[:-1]
        
        dir = makepath(sitedir, dir)
        if dir not in sys.path and os.path.exists(dir):
            sys.path.append(dir)
        

prefixes = [
    sys.prefix]
if sys.exec_prefix != sys.prefix:
    prefixes.append(sys.exec_prefix)

for prefix in prefixes:
    if prefix:
        for sitedir in sitedirs:
            pass
        
    

if os.sep == ':':
    exit = 'Use Cmd-Q to quit.'
elif os.sep == '\\':
    exit = 'Use Ctrl-Z plus Return to exit.'
else:
    exit = 'Use Ctrl-D (i.e. EOF) to exit.'
import __builtin__
__builtin__.quit = __builtin__.exit = exit
del exit

class _Printer:
    MAXLINES = 23
    
    def __init__(self, name, data, files = (), dirs = ()):
        self._Printer__name = name
        self._Printer__data = data
        self._Printer__files = files
        self._Printer__dirs = dirs
        self._Printer__lines = None

    
    def _Printer__setup(self):
        if self._Printer__lines:
            return None
        
        data = None
        for dir in self._Printer__dirs:
            for file in self._Printer__files:
                file = os.path.join(dir, file)
                
                try:
                    fp = open(file)
                    data = fp.read()
                    fp.close()
                except IOError:
                    0
                    0
                    self._Printer__files
                except:
                    0

            
        
        if not data:
            data = self._Printer__data
        
        self._Printer__lines = data.split('\n')
        self._Printer__linecnt = len(self._Printer__lines)

    
    def __repr__(self):
        self._Printer__setup()
        if len(self._Printer__lines) <= self.MAXLINES:
            return '\n'.join(self._Printer__lines)
        else:
            return 'Type %s() to see the full %s text' % (self._Printer__name,) * 2

    
    def __call__(self):
        self._Printer__setup()
        prompt = 'Hit Return for more, or q (and Return) to quit: '
        lineno = 0
        while 1:
            
            try:
                for i in range(lineno, lineno + self.MAXLINES):
                    print self._Printer__lines[i]
            except IndexError:
                break

            lineno += self.MAXLINES
            key = None
            while key is None:
                key = raw_input(prompt)
                if key not in ('', 'q'):
                    key = None
                
            if key == 'q':
                break
            


__builtin__.copyright = _Printer('copyright', sys.copyright)
__builtin__.credits = _Printer('credits', 'Python development is led by BeOpen PythonLabs (www.pythonlabs.com).')
here = os.path.dirname(os.__file__)
__builtin__.license = _Printer('license', 'See http://www.pythonlabs.com/products/python2.0/license.html', [
    'LICENSE.txt',
    'LICENSE'], [
    here,
    os.path.join(here, os.pardir),
    os.curdir])
encoding = 'ascii'
if encoding != 'ascii':
    sys.setdefaultencoding(encoding)


try:
    import sitecustomize
except ImportError:
    pass

if hasattr(sys, 'setdefaultencoding'):
    del sys.setdefaultencoding


def _test():
    print 'sys.path = ['
    for dir in sys.path:
        print '    %s,' % `dir`
    
    print ']'

if __name__ == '__main__':
    _test()

